    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------------
    028     * IntervalXYDataset.java
    029     * ----------------------
    030     * (C) Copyright 2001-2008, by Object Refinery Limited and Contributors.
    031     *
    032     * Original Author:  Mark Watson (www.markwatson.com);
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * Changes
    036     * -------
    037     * 18-Oct-2001 : Version 1, thanks to Mark Watson (DG);
    038     * 22-Oct-2001 : Renamed DataSource.java --> Dataset.java etc (DG);
    039     * 06-May-2004 : Added methods that return double primitives (DG);
    040     *
    041     */
    042
    043    package org.jfree.data.xy;
    044
    045    /**
    046     * An extension of the {@link XYDataset} interface that allows a range of data
    047     * to be defined for the X values, the Y values, or both the X and Y values.
    048     * This interface is used to support (among other things) bar plots against
    049     * numerical axes.
    050     */
    051    public interface IntervalXYDataset extends XYDataset {
    052
    053        /**
    054         * Returns the starting X value for the specified series and item.
    055         *
    056         * @param series  the series index (zero-based).
    057         * @param item  the item index (zero-based).
    058         *
    059         * @return The value.
    060         */
    061        public Number getStartX(int series, int item);
    062
    063        /**
    064         * Returns the start x-value (as a double primitive) for an item within a
    065         * series.
    066         *
    067         * @param series  the series (zero-based index).
    068         * @param item  the item (zero-based index).
    069         *
    070         * @return The start x-value.
    071         */
    072        public double getStartXValue(int series, int item);
    073
    074        /**
    075         * Returns the ending X value for the specified series and item.
    076         *
    077         * @param series  the series index (zero-based).
    078         * @param item  the item index (zero-based).
    079         *
    080         * @return The value.
    081         */
    082        public Number getEndX(int series, int item);
    083
    084        /**
    085         * Returns the end x-value (as a double primitive) for an item within a
    086         * series.
    087         *
    088         * @param series  the series index (zero-based).
    089         * @param item  the item index (zero-based).
    090         *
    091         * @return The end x-value.
    092         */
    093        public double getEndXValue(int series, int item);
    094
    095        /**
    096         * Returns the starting Y value for the specified series and item.
    097         *
    098         * @param series  the series index (zero-based).
    099         * @param item  the item index (zero-based).
    100         *
    101         * @return The value.
    102         */
    103        public Number getStartY(int series, int item);
    104
    105        /**
    106         * Returns the start y-value (as a double primitive) for an item within a
    107         * series.
    108         *
    109         * @param series  the series index (zero-based).
    110         * @param item  the item index (zero-based).
    111         *
    112         * @return The start y-value.
    113         */
    114        public double getStartYValue(int series, int item);
    115
    116        /**
    117         * Returns the ending Y value for the specified series and item.
    118         *
    119         * @param series  the series index (zero-based).
    120         * @param item  the item index (zero-based).
    121         *
    122         * @return The value.
    123         */
    124        public Number getEndY(int series, int item);
    125
    126        /**
    127         * Returns the end y-value (as a double primitive) for an item within a
    128         * series.
    129         *
    130         * @param series  the series index (zero-based).
    131         * @param item  the item index (zero-based).
    132         *
    133         * @return The end y-value.
    134         */
    135        public double getEndYValue(int series, int item);
    136
    137    }